#!/usr/bin/ruby

=begin
G?npre un fichier .res par algorithme contenant des valeurs de temps
et de solution pour des nombres d'it?ration diff?rents.
=end


#les param?tres pour tabou et popmusic
algosParams =
[["tabu_",      "-p 0             -r 1 -l 0 -i"],
 ["popmusicv1_", "-p 1 -u 40 -i 70 -r 1 -l 0 -v 0.73 1.3 15 0.77 47 18 9 -ip"]]

#les tailles de probl?me
probSizes = [100, 500]

#le nombre de s?rie
nbSeries = 15

#pour chaque taille de probl?me
probSizes.each{|size|

   #pour chaque algorithme
   algosParams.each{|params|


      #cr?e le fichier
      filename = params[0] + size.to_s + '.res'
      file = File::new(filename, 'w')
      file.puts(filename) #?crit le nom du fichier au d?but de celui c?


     #r?p?te un certain nombre de fois le calcul sur des configurations diff?rentes
      nbSeries.times{|currentSeries|

         file.puts('r ' + (currentSeries+1).to_s)

         #pour des nombres d'it?ration diff?rents
         nbIterationMax = 10
         nbIterationBefore = 0

         overlapingPercentBefore = 100 #[%]

         while nbIterationMax <= 2560

            #affiche le calcul courant :
            puts "> #{params[0]} - #{size}"

            #la taille de la zone (calcul? pour garder la m?me densit?
            #en fonction du nombre de label)
            zoneSize = (Math::sqrt(size)*2).to_i

            puts "../../cartographic_label_placement #{params[1]} #{nbIterationMax}"
            " -s #{zoneSize} #{zoneSize} -n #{size} -e #{currentSeries}"
            resultats = `../../cartographic_label_placement #{params[1]}\
 #{nbIterationMax.to_i} -s #{zoneSize} #{zoneSize} -n #{size} -e #{currentSeries}`

            /Number of iteration : (\d+).*Number of overlaping\
 : (\d+).*Time of computation : (\d+)/m =~ resultats


            nbIteration = $1.to_i
            overlapingPercent = 100.0 * ($2.to_f / size.to_f)
            timeSec = $3.to_f / 1000.0

            break if nbIteration == nbIterationBefore

            #puts "#{overlapingPercent} <= #{overlapingPercentBefore}"
            if overlapingPercent < overlapingPercentBefore
               file.puts(format("%11i%11.2f%12.2f", nbIteration.to_f, overlapingPercent, timeSec))
               overlapingPercentBefore = overlapingPercent
            end

            nbIterationBefore = nbIteration

            nbIterationMax *= 2.0
         end
      }
   }
}
