#!/usr/bin/ruby

=begin
Effectue plusieurs rsolution de problme en faisant varier la taille du problme de
50  6400 par facteur de 2 sur les 2 algorithmes : tabou et popmusic.
un fichier par algo est cre, il se prsente sous la forme de 2 colonnes :
<taille du problme> <temps de calcul>.

Effectue galement une mesure du temps de l'initialisation.
=end

#les paramtres pour tabou et popmusic
#on ne tient pas compte du temps d'initialisation
algosParams =
[["tabu.txt",     "-ti 0 -p 0       -i 5000 -r 1 -l 0 "],
 ["popmusic1.txt", "-ti 0 -p 1 -u 70 -i   75 -r 1 -l 0 -v 0.73 1.3 15 0.77 47 18 9 "],
 ["popmusic2.txt", "-ti 0 -p 2 -u 70 -i   75 -r 1 -l 0 -v 0.73 1.3 15 0.77 47 18 9 "],
 #pour mesurer le temps d'initialisation (-ti 2)
 ["ini.txt",      "-ti 2 -p 0       -i 1 -r 1 -l 0 "]]

#le nombre de problme (en fait la moyenne)
nbSeries = 10

#pour chaque algorithme
algosParams.each{|params|

   #cre le fichier
   file = File::new(params[0], 'w')

   #pour plusieurs tailles de problme
   size = 50
   while(size <= 6400)

      time = 0; #comptabilise le temps

      nbSeries.times{|serie|

         #affiche le calcul courant :
         puts "> #{params[0]} - #{size}"

         #la taille de la zone (calcul pour garder la mme densit en fonction du nombre de label)
         zoneSize = (Math::sqrt(size)*2).to_i

         puts "../../cartographic_label_placement #{params[1]}" +
            " -s #{zoneSize} #{zoneSize} -n #{size} -e #{serie}"
            
         resultats = `../../cartographic_label_placement #{params[1]}\
 -s #{zoneSize} #{zoneSize} -n #{size} -e #{serie}`

         /Time of computation : (\d+)/ =~ resultats

         time += $1.to_f
      }


      file.puts(format("%15i%15.2f", size, time/nbSeries.to_f))

      size *= 2
   end
}
