#!/bin/bash

#applique POPMUSIC+TABU  tous les problmes
#de la taille qui est donne en
#paramtre (les problmes se trouve dans
#le rpertoire 'data').

#vrifie qu'il y ait bien 3 paramtres
if (( $# != 3 )); then
   echo "Usage : batch.sh <POPMUSIC version : 1|2> <size of the subsets> <file num>"
   exit
fi

#cre le fichier o seront stock les rsultats
echo -n '' > batch.txt

#le dbut du nom du fichier de donne
fichier="../../data/$3/d$3_"

#compteur de boucle
nb=1;

#pour chaque fichier
while (( $nb <=  25 )); do

   #complte le numero du fichier pour qu'il soit toujours sur 2 digit
   if (($nb < 10)); then
      zero='0'
   else
      zero=''
   fi

  echo "fichier numero : $zero$nb"

  echo "fichier :  $fichier$zero$nb.dat" >> batch.txt


   #####lancement du calcul
   #(-p 1):activation de POPMUSIC
   #(-f ):le fichier de donnes
   #(-i 70):le nombre d'iteration
   #(-u 75):la taille des sous-problmes
   #(-d 1):le germe (pour choisir les sous-ensembles)
   #(-v ):les paramtres
   #(-r 1):pour ne pas tenir compte des positions de labels
   ../../cartographic_label_placement\
   -p $1\
   -f $fichier$zero$nb.dat\
   -i 70\
   -u $2\
   -d 1\
   -v 0.73 1.3 15 0.77 47 18 9\
   -r 1 >> batch.txt || exit
   #####

   #incrment le compteur
   nb=$(($nb + 1))
done

#calcul la moyenne du nombre de chevauchement ainsi
#que du temps de calcul de la meilleure solution
#et enregistre le rsultats dans 'averages.txt'
awk '
BEGIN {
nbOverlap = 0;
nbPoint = 0;

bestSolution = 99999;
bestOk = 0;
computeTime = 0;
}
(NR-13) % 15 == 0{
   nbOverlap += $5;
   nbPoint += 1;

   if(nbOverlap < bestSolution)
   {
      bestSolution = nbOverlap;
      bestOk = 1;
   }
}
(NR-14) % 15 == 0{
   if(bestOk)
   {
      computeTime = $5;
      bestOk = 0;
   }
}
END {
print "Nombre de chevauchement moyen       : ", nbOverlap/nbPoint;
print "Temps de la meilleure solution [ms] : ", computeTime
}
' batch.txt >> averages.txt
