#!/usr/bin/ruby

=begin
Effectue une recherche dichotomique des paramtres
pour amliorer l'efficacit de la recherche avec Tabou
=end

##########DONNEES##########

#le nombre d'itration
$nbIteration = 70

#le nombre d'tiquette
$nbLabel = 40

params = [
#la taille de la la liste de candidats initiale
[0.1, 0.8],

#le facteur de rduction de la taille de la liste des candidats
[1.1, 1.5],

#le facteur d'agrandissement de la taille de la liste des candidats
[5.0, 20.0],

#la taille de la liste tabou par rapport au nombre de chevauchement
[0.1, 0.8],

#la nombre d'iteration avant de recalculer la taille des listes
[10.0, 50.0],

#la taille minimale de la liste de candidats
[2.0, 20.0],

#la taille minimal de la liste tabou
[2.0, 10.0]]


#Le nombre de configuration de test  chaque itration
$nbConfiguration = 500

#Le taux de densit dfinissant la taille de la surface, calcul comme ceci :
# size = sqrt(nombre_de_label)*densit
$densityArray = [2, 2.5, 3]

#le nombre d'itration de recherche
nbIterationSearch = 200

##########FIN DONNEES##########

#pourcentage de dplacement de la valeur
$diplacePercent = 0.2 #20%

=begin
effectue une srie de calculs
=end
def runAComputation(candidateSizeBase,
candidateReduceFactor, candidateGrowingFactor, tabuSize,
nbIterationListSizeRecompute, minimalCandidateListSize, minimalTabuListSize, seedBase)

   nbOverlapInitial = 0.0
   nbOverlapFinal = 0.0
   time = 0.0

   seed = seedBase
   $nbConfiguration.times{

      $densityArray.each{|density|
         size = (Math::sqrt($nbLabel)*density).to_i

         #permet d'avoir des configuration diffrentes  chaque essais
         #mais des ensembles de configuration identiques
         seed += 1

         resultats = `../../cartographic_label_placement -i #{$nbIteration}\
         -n #{$nbLabel} -s #{size} #{size} -e #{seed} -v #{candidateSizeBase}\
         #{candidateReduceFactor} #{candidateGrowingFactor} #{tabuSize}\
         #{nbIterationListSizeRecompute.to_i} #{minimalCandidateListSize.to_i}\
         #{minimalTabuListSize.to_i}`

         /Number of initial overlaping : (\d+).*Number of overlaping\
 : (\d+).*Time of computation : (\d+)/m =~ resultats

         nbOverlapInitial += $1.to_f
         nbOverlapFinal += $2.to_f
         time += $3.to_f
      }
   }
   nbOverlapInitial /= $densityArray.size + $nbConfiguration
   nbOverlapFinal /= $densityArray.size + $nbConfiguration
   time /= $densityArray.size + $nbConfiguration

   [nbOverlapFinal, time]
end


#renvois la moyenne entre 2 valeurs se trouvant dans un tableau
def average(values)
   (values[0]+values[1])/2.0
end


nbIterationSearch.times{|i|

   #si la diffrence entre les 2 valeurs est trop faible alors n'essais pas de les amliorer :
   next if params[i % 7][0] + 0.02 > params[i % 7][1]

   results = Array::new

   #un nombre entre 0 et 100000000
   seed = rand(100000000)

   #effectue 2 sries, utilisant respectivement la premire
   #valeur du paramtre courant et la deuxime valeur
   2.times{|j|

      results[j] = runAComputation(
         ((i + 7) % 7 == 0 ? params[0][j] : average(params[0])),
         ((i + 6) % 7 == 0 ? params[1][j] : average(params[1])),
         ((i + 5) % 7 == 0 ? params[2][j] : average(params[2])),
         ((i + 4) % 7 == 0 ? params[3][j] : average(params[3])),
         ((i + 3) % 7 == 0 ? params[4][j] : average(params[4])),
         ((i + 2) % 7 == 0 ? params[5][j] : average(params[5])),
         ((i + 1) % 7 == 0 ? params[6][j] : average(params[6])), seed)
   }

   #compare les deux rsultats (en terme de chevauchement)
   if results[0][0] < results[1][0]
      #si la premire valeur  donner un meilleur rsultat alors
      #remplace la deuxime par une pond?ration de n% de la premire et de 100-n% de la deuxime
      params[i % 7][1] = params[i % 7][0]*$diplacePercent+params[i % 7][1]*(1.0-$diplacePercent)
   elsif results[0][0] > results[1][0]
      #si la deuxime valeur  donner un meilleur rsultat alors
      #remplace la deuxime par une pondration de 100-n% de la premire et de n% de la deuxi?me
      params[i % 7][0] = params[i % 7][1]*$diplacePercent+params[i % 7][0]*(1.0-$diplacePercent)
   end

   #affiche le rsultat
   puts "------#{i % 7}------" #le numro du paramtre test
   puts "iteration : #{i}" #le numro de l'itration
   puts "#{format("%.4f", results[0][0])} <=> #{format("%.4f", results[1][0])}"
   puts 'Parms : '
   params.each{|p| #les paramtres
      puts "#{format("%.4f", p[0])} #{format("%.4f", p[1])}"
   }
}

