/**
  * Classe reprsentant une ensemble de point ayant chacun
  * un label le dfinissant.
  * C'est la donne  optimiser.
  */

#ifndef _MAP_H_
#define _MAP_H_

#include <vector>
#include <string>
using namespace std;

#include <qfont.h>

#include "Point.cpp"

/**
  * Un element de la map
  */
struct MapElement
{
	/**
        * Constructeur.
	  * p1 : la position du point
          * p2 : la largeur du label
	  * p3 : la hauteur du label
    	  */
	MapElement(Point<double>, double, double);
	// p4 : le poids du label
	MapElement(Point<double>, double, double, double);

	/**
        * Constructeur.
	  * p1 : la position du point
	  * p2 : le poids du label
	  * p3 : le texte
	  * p4 : la police du texte
    	  */
	MapElement(Point<double>, double, string, QFont);
	MapElement();

	//destructeur
	~MapElement()
	{
	}

	/**
	  * Renvois vrai si le label  un texte associ
	  */
	bool haveText() const;

	Point<double> position;
	double l; //largeur
	double h; //hauteur
	double weight; //le poids
	string text; //le texte du label
	QFont font;
};

class Map
{
public :

	/**
	  * Constructeur et destructeur.
	  */
	Map()
	{
		this->points = new vector<MapElement*>();
		this->maxLimit.x = -9999999;
		this->maxLimit.y = -9999999;
		this->minLimit.x = 9999999;
		this->minLimit.y = 9999999;
	}
	~Map()
	{
		for(int i = 0; i<int(this->points->size()); i++)
			delete (*this->points)[i];

		delete this->points;
	}

	/**
	  * Renvois le nombre de label
	  */
	int getNbPointLabel() const;

	/**
	  * Renvois un point.
	  * p1 : le numro du label
	  */
	MapElement* getPointLabel(int) const;

	/**
	  * Renvois la limite infrieure.
	  */
	Point<double> getMinLimit() const;

	/**
	  * Renvois la limite suprieure.
	  */
	Point<double> getMaxLimit() const;

	/**
	  * Assigne un point et son label
	  * p1 : le point et son label
	  */
	void addPointLabel(MapElement*);

	/**
	  * Masque une zone de point.
	  * p1 : la zone (droit, haut, gauche, bas)
	  ******* A MODIFIER POUR NE PLUS ENLEVER
	  LES POINTS MAIS POUR
	  REELEMENT LES MASQUER *****
	  */
	void doMasking(double*);

private :
	
	//tous les points ainsi que leur label respectif
	vector<MapElement*>* points;

	//les limites de la zone
	//limites infrieurs (point situ en bas  gauche)
	Point<double> minLimit;
	
	//limites suprique (point situ en bas  droite)
	Point<double> maxLimit;

	//marge (pourcentage de la taille totale)
	static const double marginPercent;
};

#endif
