#include "MapFileReader.h"

#include <iostream>
#include <string>
#include <cmath>
using namespace std;

#include <qfont.h>

//###############//
MapFileReader::MapFileReader(const char* name)
{
	ifstream file(name);
	if(!file)
	{
		cerr << "Error : the file " << name << " doesn't exist" << endl;
		exit(1);
	}

	int nbPoint; //le nombre de point

	file >> nbPoint;

	this->map = new Map();

	for(int i=0; i<nbPoint; i++)
	{
		int x, y;
		double weight;
		
		file >> x;
		file >> y;
		file >> weight;

		char tmp[255];
		file.get(tmp, 255);
		string cityName = string(tmp);

		//n'ajoute pas les villes qui n'ont pas de poids
		if(weight == 0.0 || cityName.size() == 0) continue;

		QFont font("Helvetica", 10);
		
		//pour les villes de plus de 100'000 habitants
		if(weight > 100000)
		{
			font.setPointSize(16);
			font.setBold(true);
		}
		//pour les villes de plus de 20'000 habitants
		else if(weight > 20000)
		{
			font.setPointSize(12);
			font.setBold(true);
		}

		this->map->addPointLabel(new MapElement(Point<double>(x, y), weight, cityName, font));
	}
}

//###############//
Map* MapFileReader::getMap()
{
	return this->map;
}
