#include "Nav.h"
using namespace Gui;

#include <qlayout.h>
#include <qlabel.h>
#include <qvalidator.h>

//###############//
Nav::Nav(QWidget* parent, const char* name)
: QDialog(parent, name, false, Qt::WStyle_Customize | Qt::WStyle_DialogBorder)
{
	this->setCaption("Nav");

	QLabel* lblZoom = new QLabel("Zoom [%]", this);
	this->textZoom = new QLineEdit("100", this);
	this->textZoom->setValidator(new QIntValidator(10, 1000, this->textZoom));

	this->sliZoom = new QSlider(10, 1000, 10, 100, Qt::Horizontal, this);

	QGridLayout* grid = new QGridLayout(this, 2, 3);

	grid->addWidget(lblZoom, 1, 1);
	grid->addWidget(this->textZoom, 1, 3);

	grid->addMultiCellWidget(this->sliZoom, 2, 2, 1, 3);

	grid->setColSpacing(2, 10);
	grid->setMargin(5);

	this->setMaximumSize(QSize(100, 0));
	this->resize(QSize(100, 0));

	connect(this->textZoom, SIGNAL(textChanged(const QString&)),
		this, SLOT(setZoomText(const QString&)));

	connect(this->sliZoom, SIGNAL(valueChanged(int)),
		this, SLOT(setZoomSli(int)));
}	

//###############//
void Nav::setZoomText(const QString& s)
{
	int v = s.toInt();
	if(v >= 10 && v <= 1000)
	{
		this->sliZoom->setValue(v);
		emit zoomChanged(v);
	}
}

//###############//
void Nav::setZoomSli(int v)
{
	this->textZoom->setText(QString::number(v));
}
