/**
  * Fentre de navigation, zoom, position etc.
  */

#ifndef _NAV_H_
#define _NAV_H_

#include <qwidget.h>
#include <qdialog.h>
#include <qlineedit.h>
#include <qslider.h>
#include <qstring.h>

namespace Gui
{
	class Nav : public QDialog
	{
		Q_OBJECT

	public :
		/**
		  * Constructeur.
		  * p1-3 : voir classe de base
		  */
		Nav(QWidget* parent=0, const char* name=0);	

	signals :
		/**
		  * Signal mit lorsque le zoom est modifi.
		  * p1 : la valeur du zoom
		  */
		void zoomChanged(int);
	
	private slots :

		/**
		  * Dfinit la valeur du zoom du champs de texte.
		  * p1 : la valeur du zoom
		  */
		void setZoomText(const QString&);
		
		/**
		  * Dfinit la valeur du zoom du slider.
		  * p1 : la valeur du zoom
		  */
		void setZoomSli(int);

	private :
	
		//la zone de texte	
		QLineEdit* textZoom;

		//le slider
		QSlider* sliZoom;
	};
}

#endif
