/**
  * Boite de dialogue permettant de gnrer alatoirement
  * une configuration initiale.
  */

#ifndef _RAND_GEN_H_
#define _RAND_GEN_H_

#include <qdialog.h>
#include <qwidget.h>
#include <qlineedit.h>
#include <qcheckbox.h>

#include "../Map.h"

namespace Gui
{
	class RandGen : public QDialog
	{
		Q_OBJECT
	public :
		/**
		  * Constructeur.
		  * p1-3 : voir classe de base
		  */
		RandGen(QWidget* parent=0, const char* name=0);
	
		/**
		  * Renvois la map gnre.
		  */
		Map* getMap();

	private slots :

		/**
		  * Appell lorsque le bouton 'OK' est press.
		  */
		void accept();

	private :

		//les widgets
		QLineEdit* textNbLabel;
		QLineEdit* textSizeX;
		QLineEdit* textSizeY;
		QLineEdit* textSeed;
		QLineEdit* textLabelWidth;
		QLineEdit* textLabelHeight;
		QCheckBox* checkIntLabelPosition;	

		//la map gnre
		Map* map;
	};
}

#endif
