/**
  * Fentre affichant les diffrents rsultats
  */

#ifndef _RESULTS_H_
#define _RESULTS_H_

#include <qwidget.h>
#include <qdialog.h>
#include <qlineedit.h>

#include "../LabelPlacement.h"

namespace Gui
{
	class Results : public QDialog
	{
		Q_OBJECT

	public :
		/**
		  * Constructeur.
		  * p1-3 : voir classe de base
		  */
		Results(QWidget* parent=0, const char* name=0);	
	
	public slots :
		/**
		  * Demande l'affichage des rsultats.
		  * p1 : le placement de label.
		  */
		void setResults(LabelPlacement*);

	private :

		/**
		  * Renvois l'heure format sous la forme : H-Min-Sec.
		  * p1 : l'heure en miliseconde
		  */
		QString formatTime(int) const;

		//les widgets
		QLineEdit* textInitialOverlaping;
		QLineEdit* textFinalOverlaping;
		QLineEdit* textNbIteration;
		QLineEdit* textInitTime;
		QLineEdit* textCompTime;
	};
}

#endif
