#include "ProblemsGenerator.h"

#include <cstdlib>
#include <ctime>
using namespace std;

#include "../Point.cpp"

//###############//
ProblemsGenerator::ProblemsGenerator(int nbLabel, double* size, int seed,
	double* labelSize, bool intLabelPosition)
{
	this->map = new Map();

	srand(seed == -1 ? time(0) : seed);
	
	//place chaque label sur une position alatoire uniformement rapartie 
	//sur la surface
	for(int i=0; i<nbLabel; i++)
	{
		double labelWidth = labelSize == 0 ? (double(rand())/RAND_MAX) * 30 + 10 : labelSize[0];
		double labelHeight = labelSize == 0 ? 8 : labelSize[1];
		
		Point<double> p((double(rand())/RAND_MAX) * size[0], (double(rand())/RAND_MAX) * size[1]);

		//si les coordonnes du point doivent tre entires
		if(intLabelPosition)
		{
			p.x = int(p.x+0.5);
			p.y = int(p.y+0.5);
		}

		this->map->addPointLabel(new MapElement(p,labelWidth ,labelHeight));
	}
}

//###############//
Map* ProblemsGenerator::getMap() const
{
	return this->map;
}
