#include "CostLabelList.h"
using namespace Tabu;

#include <algorithm>
using namespace std;

#define ns CostLabelList

//permet de trier les labels par leur cot
struct Cmp
{
     bool operator()(const CostLabel& c1, const CostLabel& c2)
     {
          return c1.cost < c2.cost;
     }
};

//###############//
ns::CostLabelList(const SolutionTabu& position, const OverlapManager& om)
: vector<CostLabel>(position.size())
{
	//calcul le cot de tous les labels
	for(int i = 0; i<int(position.size()); i++)
		(*this)[i] = CostLabel(om.cost(i), i);

	sort<CostLabelList::iterator, Cmp>(this->begin(), this->end(), Cmp());
}

//###############//
void ns::updateCost(CostLabelList::iterator i, double cost)
{
	i->cost = cost;
	sort<CostLabelList::iterator, Cmp>(this->begin(), this->end(), Cmp());
}

#undef ns
