#include "PlacementDirectives.h"
using namespace Tabu;

//###############//
PlacementDirectives::PlacementDirectives(const double* p, int nbPosition,
	double pointLabelLength, double ratioOverlap)
{
	this->ratioOverlap = ratioOverlap;

	if(pointLabelLength >= 0)
		this->pointLabelLength = pointLabelLength;
	else 
		throw new ErrorDirectives();

	this->nbPosition = nbPosition;
	this->positionPreferences = p;

	//vrifie la validit des prfrences
	for(int i = 0; i < this->nbPosition; i++)
		if(this->positionPreferences[i] > 1 || this->positionPreferences[i] < 0)
			throw new ErrorDirectives();
}

//###############//
double PlacementDirectives::getPreference(int num) const
{
	//vrifie si la prfrence existe
	if(num <= this->nbPosition && num >= 0)
		return  this->positionPreferences[num];
	throw new ErrorDirectives();
}

//###############//
int PlacementDirectives::getNbPosition() const
{
	return this->nbPosition;
}

//###############//
double PlacementDirectives::getPointLabelLength() const
{
	return this->pointLabelLength;
}

//###############//
void PlacementDirectives::setNbPosition(int nb)
{
	this->nbPosition = nb;
}

//###############//
double PlacementDirectives::getRatioOverlap() const
{
	return this->ratioOverlap;
}
