/**
  * Reprsente une solution c--d la position de chaque label.
  */

#ifndef _TABU_SOLUTIONTABU_H_
#define _TABU_SOLUTIONTABU_H_

#include <vector>
using namespace std;

namespace Tabu
{

	class SolutionTabu : public vector<int>
	{	
	public :

		/**
		  * Constructeur, initialise le nombre de label  0.
		  */
		SolutionTabu() : vector<int>(0){}

		/**
		  * Constructeur.
		  * p1 : le nombre de label de la solution
		  */
		SolutionTabu(int n) : vector<int>(n){}

		/**
		  * Destructeur.
		  */
		virtual ~SolutionTabu(){}

		/**
		  * Permet d'acceder  la position d'un label.
		  * p1 : le numro du du label
		  */
		virtual value_type& operator[](size_type i)
		{	
			return *(begin() + i);
		}
	
		/**
		  * Permet d'acceder  la position d'un label, renvois un const.
		  * p1 : le numro du du label
		  */
		virtual const value_type& operator[](size_type i) const
		{	
			return *(begin() + i);
		}

		/**
		  * Renvois la taille de la solution, renvois la taille du sous-ensemble si il est actif.
		  */
		virtual size_type size() const
		{
			return vector<int>::size();
		}
	};
}

#endif
