/**
  * Permet de gnrer une image pixmap d'une solution
  */

#ifndef _TOOLS_IMAGEGENERATOR_H_
#define _TOOLS_IMAGEGENERATOR_H_

#include <string>
using namespace std;

#include <qimage.h>

//reprsente un solution complte
#include "../Solution.h"
#include "../Map.h"

namespace Tools
{
	class ImageGenerator
	{
	public :

		/**
		  * Constructeur.
		  * p1 : l'emplacement des labels
		  * p2 : la solution  gnrer
		  * p3 : la taille de l'image de sortie
		  */
		ImageGenerator(const Map*, const Solution*, int);

		/**
		  * Ecrit l'image dans un fichier.
		  * p1 : le nom du fichier
		  */
		void writeImageInAFile(string);

	private :

		/**
		  * Dessine un rectangle sur un "QImage".
		  * p1 : l'image
		  * p2 : le coin infrieur gauche du rectangle
		  * p3 : le coins suprieur droite du rectangle
		  * p4 : la couleur
		  * p5 : en trait-till (ortho) ? (pour afficher les labels qui entre en collision)
		  */ 
		void drawRect(QImage&, const Point<int>&, const Point<int>&, uint, bool) const;

		/**
		  * Dessine une pixel sur un "QImage" en vrifiant sa validit.
		  * p1 : l'image
		  * p2 : le coin infrieur gauche du rectangle
		  * p3 : le coins suprieur droite du rectangle
		  * p4 : la couleur
		  */ 
		void drawPixel(QImage&, int, int, uint) const;
		
		/**
		  * Convertit une coordonne sur le "map" vers une coordonne sur l'image bitmap.
		  * p1 : Le point  convertir
		  */
		Point<int> conversionToPixmap(const Point<double>) const;

		const Map* map; //les labels

		const Solution* solution; //la solution

		int bitmapSize; //la taille de l'image (le cot le plus grand)
		int nbPixelBorder; //le nombre de pixel de marge autour des labels
		double factor; //le facteur entre le map et l'image bitmap
		int imageW, imageH; //la taille de l'image
		Point<double> minCorner;//la coodonne minimum
	};
}

#endif
