#!/usr/bin/ruby

#Compte le nombre de caractre de chaque ligne d'un ou plusieurs fichier et avertit quelle ligne dans quel fichier excde une certaine valeur.
#Le programme recoit 2 paramtres : le nombre de caracre max et le nom du rpertoire ou d'un fichier

#Auteur : G.Burri


#vrifie le nombre de paramtre :
if $*.size != 2
	puts "Usage: #{$0} (<File>|<Dir>) <string to search>"
	exit 0
end

$STRING = Regexp::new($*[1])


# appliquer  chaque ligne :
=begin
def computeLine(line, file, numLigne)
	lineSize = line.size + line.count('	')*$TAB_SIZE
		if lineSize > $*[1].to_i
			puts "File : #{file}  line : #{numLigne}  nb character : #{lineSize}"
		end
end
=end

$NB_LINE_MATCHED = 0

def computeLine(line, file, numLigne)
	
	if $STRING.match(line)
		puts "File : #{file} at line #{numLigne} : #{line}"
		$NB_LINE_MATCHED += 1
	end
end


#vrifie uniquement les fichiers correspondant  cet expression rationnelle
$VALID_EXT = /.*\.(cpp|c|h|txt|rb|py|sh|bash)$/

#la taille des tabs :
$TAB_SIZE = 3

#compte le nombre de ligne non-vide
$nb_line = 0

#vrifie un rpertoire
def checkDir(dir)
	Dir::foreach(dir){|file|
		next if file == '.' || file == '..'
		path = dir+'/'+file
		if File::directory?(path)
			checkDir(path)
		else
			checkFile(path)
		end
	}
end

#vrifie un fichier
def checkFile(file)
	if $VALID_EXT =~ file
		i = 0
		IO::foreach(file){|line|
			$nb_line += 1 if /\S+/ =~ line
			i += 1
			computeLine(line, file, i)
		}
	end
end	

if File::directory?($*[0])
	checkDir($*[0])
else
	checkFile($*[0])
end

puts "Number of matched line    : #{$NB_LINE_MATCHED}"
puts "Number of none empty line : #{$nb_line}"

